diff --git a/src/main/java/net/minecraft/client/gui/achievements/data/AchievementPage.java b/src/main/java/net/minecraft/client/gui/achievements/data/AchievementPage.java
new file mode 100644
index 000000000..3d32ea5e1
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/achievements/data/AchievementPage.java
@@ -0,0 +1,54 @@
+package net.minecraft.client.gui.achievements.data;
+
+import net.minecraft.client.gui.achievements.GuiAchievements;
+import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.core.achievement.Achievement;
+import net.minecraft.core.achievement.stat.StatsCounter;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.Side;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.List;
+import java.util.Random;
+
+public abstract class AchievementPage {
+
+    public abstract @NotNull String getName();
+
+    public abstract @NotNull String getDescription();
+
+    public abstract void addAchievement(@NotNull Achievement achievement);
+
+    public abstract @NotNull Achievement onOpenAchievement();
+
+    public abstract @Nullable IconCoordinate getBackgroundTile(GuiAchievements gui, int layer, Random random, int tileX, int tileY);
+
+    public abstract void postProcessBackground(GuiAchievements gui, Random random, GuiAchievements.BGLayer layerCache, int orgX, int orgY);
+
+    public abstract @NotNull ItemStack getIcon();
+
+    public abstract @NotNull List<Achievement> getAchievements();
+
+    public abstract double getCompletionFraction(StatsCounter counter);
+
+    public abstract int backgroundLayers();
+
+    public abstract int backgroundColor();
+
+    public abstract boolean hasAchievement(Achievement achievement);
+
+    public abstract IconCoordinate getAchievementIcon(Achievement achievement);
+
+    public abstract int lineColorLocked(boolean isHovered);
+
+    public abstract int lineColorUnlocked(boolean isHovered);
+
+    public abstract int lineColorCanUnlock(boolean isHovered);
+
+    public static IconCoordinate getTextureFromBlock(Block block){
+        return BlockModelDispatcher.getInstance().getDispatch(block).getBlockTextureFromSideAndMetadata(Side.TOP, 0);
+    }
+}
diff --git a/src/main/java/net/minecraft/client/gui/achievements/data/AchievementPageRegistry.java b/src/main/java/net/minecraft/client/gui/achievements/data/AchievementPageRegistry.java
new file mode 100644
index 000000000..ac756e4ad
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/achievements/data/AchievementPageRegistry.java
@@ -0,0 +1,48 @@
+package net.minecraft.client.gui.achievements.data;
+
+import java.util.ArrayList;
+import java.util.Collections;
+import java.util.List;
+
+public class AchievementPageRegistry {
+    private static final AchievementPageRegistry INSTANCE = new AchievementPageRegistry();
+
+    public static AchievementPageRegistry getInstance()
+    {
+        return INSTANCE;
+    }
+
+    private final List<AchievementPage> pages = new ArrayList<>();
+
+    private AchievementPageRegistry() { }
+
+    public void register(AchievementPage page)
+    {
+        if (!pages.contains(page))
+        {
+            pages.add(page);
+
+            // Move search page to the end
+//            if (OptionsPages.SEARCH != null)
+//            {
+//                pages.remove(OptionsPages.SEARCH);
+//                pages.add(OptionsPages.SEARCH);
+//            }
+        }
+    }
+
+    public int getPageIndex(AchievementPage page)
+    {
+        return pages.indexOf(page);
+    }
+
+    public List<AchievementPage> getPages()
+    {
+        return Collections.unmodifiableList(pages);
+    }
+
+    static
+    {
+        AchievementPages.init();
+    }
+}
\ No newline at end of file
diff --git a/src/main/java/net/minecraft/client/gui/achievements/data/AchievementPages.java b/src/main/java/net/minecraft/client/gui/achievements/data/AchievementPages.java
new file mode 100644
index 000000000..072688dbc
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/achievements/data/AchievementPages.java
@@ -0,0 +1,46 @@
+package net.minecraft.client.gui.achievements.data;
+
+import net.minecraft.client.gui.achievements.pages.DefaultPage;
+import net.minecraft.client.gui.achievements.pages.NetherPage;
+import net.minecraft.client.gui.achievements.pages.OverworldPage;
+import net.minecraft.core.achievement.Achievements;
+import net.minecraft.core.block.Blocks;
+
+public class AchievementPages {
+    public static AchievementPage overworldPage;
+    public static AchievementPage netherPage;
+
+    public static AchievementPage register(AchievementPage page){
+        AchievementPageRegistry.getInstance().register(page);
+        return page;
+    }
+
+    private static boolean hasInit = false;
+    public static void init(){
+        if (hasInit) return;
+        hasInit = true;
+        overworldPage = register(new OverworldPage());
+        netherPage = register(new NetherPage());
+//        netherPage = new NetherPage();
+
+        register(new DefaultPage("DUMMY PAGE", Blocks.SPONGE_DRY.getDefaultStack()));
+        register(new DefaultPage("DUMMY PAGE", Blocks.SPONGE_DRY.getDefaultStack()));
+        register(new DefaultPage("DUMMY PAGE", Blocks.SPONGE_DRY.getDefaultStack()));
+        register(new DefaultPage("DUMMY PAGE", Blocks.SPONGE_DRY.getDefaultStack()));
+        register(new DefaultPage("DUMMY PAGE", Blocks.SPONGE_DRY.getDefaultStack()));
+        register(new DefaultPage("DUMMY PAGE", Blocks.SPONGE_DRY.getDefaultStack()));
+        register(new DefaultPage("DUMMY PAGE", Blocks.SPONGE_DRY.getDefaultStack()));
+        register(new DefaultPage("DUMMY PAGE", Blocks.SPONGE_DRY.getDefaultStack()));
+        register(new DefaultPage("DUMMY PAGE", Blocks.SPONGE_DRY.getDefaultStack()));
+        register(new DefaultPage("DUMMY PAGE", Blocks.SPONGE_DRY.getDefaultStack()));
+        register(new DefaultPage("DUMMY PAGE", Blocks.SPONGE_DRY.getDefaultStack()));
+        register(new DefaultPage("DUMMY PAGE", Blocks.SPONGE_DRY.getDefaultStack()));
+        register(new DefaultPage("DUMMY PAGE", Blocks.SPONGE_DRY.getDefaultStack()));
+        register(new DefaultPage("DUMMY PAGE", Blocks.SPONGE_DRY.getDefaultStack()));
+        register(new DefaultPage("DUMMY PAGE", Blocks.SPONGE_DRY.getDefaultStack()));
+    }
+    static {
+        Achievements.init();
+        init();
+    }
+}
diff --git a/src/main/java/net/minecraft/client/gui/achievements/pages/DefaultPage.java b/src/main/java/net/minecraft/client/gui/achievements/pages/DefaultPage.java
new file mode 100644
index 000000000..30f0d6d52
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/achievements/pages/DefaultPage.java
@@ -0,0 +1,476 @@
+package net.minecraft.client.gui.achievements.pages;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.achievements.GuiAchievements;
+import net.minecraft.client.gui.achievements.data.AchievementPage;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.core.WeightedRandomBag;
+import net.minecraft.core.achievement.Achievement;
+import net.minecraft.core.achievement.Achievements;
+import net.minecraft.core.achievement.stat.StatsCounter;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.ArrayList;
+import java.util.List;
+import java.util.Objects;
+import java.util.Random;
+import java.util.function.BiFunction;
+
+public class DefaultPage extends AchievementPage {
+    protected final Minecraft mc = Minecraft.getMinecraft(this);
+    protected final ItemStack icon;
+    @NotNull
+    private final List<Achievement> achievementList = new ArrayList<>();
+    protected final String key;
+    public DefaultPage(String key, ItemStack icon){
+        this.key = key;
+        this.icon = icon;
+    }
+    @Override
+    public void addAchievement(@NotNull Achievement achievement){
+        achievementList.add(Objects.requireNonNull(achievement));
+    }
+    @Override
+    public @NotNull String getName() {
+        return I18n.getInstance().translateNameKey(key);
+    }
+
+    @Override
+    public @NotNull String getDescription() {
+        return I18n.getInstance().translateDescKey(key);
+    }
+
+    @Override
+    public @NotNull Achievement onOpenAchievement() {
+        return Achievements.BUILD_WORKBENCH;
+    }
+
+    protected static final int ORE_COAL = 0;
+    protected static final int ORE_IRON = 1;
+    protected static final int ORE_GOLD = 2;
+    protected static final int ORE_DIAMOND = 3;
+    protected static final int ORE_REDSTONE = 4;
+    protected static final int ORE_LAPIS = 5;
+    protected static final Block[] STONE_ORES = new Block[]     { Blocks.ORE_COAL_STONE,    Blocks.ORE_IRON_STONE,      Blocks.ORE_GOLD_STONE,      Blocks.ORE_DIAMOND_STONE,       Blocks.ORE_REDSTONE_STONE,      Blocks.ORE_LAPIS_STONE};
+    protected static final Block[] GRANITE_ORES = new Block[]   { Blocks.ORE_COAL_GRANITE,  Blocks.ORE_IRON_GRANITE,    Blocks.ORE_GOLD_GRANITE,    Blocks.ORE_DIAMOND_GRANITE,     Blocks.ORE_REDSTONE_GRANITE,    Blocks.ORE_LAPIS_GRANITE};
+    protected static final Block[] LIMESTONE_ORES = new Block[] { Blocks.ORE_COAL_LIMESTONE,Blocks.ORE_IRON_LIMESTONE,  Blocks.ORE_GOLD_LIMESTONE,  Blocks.ORE_DIAMOND_LIMESTONE,   Blocks.ORE_REDSTONE_LIMESTONE,  Blocks.ORE_LAPIS_LIMESTONE};
+    protected static final Block[] BASALT_ORES = new Block[]    { Blocks.ORE_COAL_BASALT,   Blocks.ORE_IRON_BASALT,     Blocks.ORE_GOLD_BASALT,     Blocks.ORE_DIAMOND_BASALT,      Blocks.ORE_REDSTONE_BASALT,     Blocks.ORE_LAPIS_BASALT};
+
+    @Override
+    public IconCoordinate getBackgroundTile(GuiAchievements guiAchievements, int layer, Random random, int tileX, int tileY) {
+        random.setSeed(random.nextLong() + key.hashCode()); // makes seed different for each instance of this class :)
+        // expect x range from  0  to 45
+        // expect y range from -12 to 50
+        final int sandLayer = -20;
+        final int dirtLayer = 2;
+        final int bedrockLayer = 35;
+        final int stoneLayer = bedrockLayer - (int) ((bedrockLayer - dirtLayer) * 0.5f);
+        final int basaltLayer = bedrockLayer - (int) ((bedrockLayer - dirtLayer) * 0.25f);
+
+        final int graniteColumn = 5;
+        final int limestoneColumn = 50;
+
+        final int offsetX = tileX + random.nextInt(3) - random.nextInt(3);
+        final int offsetY = tileY + random.nextInt(3) - random.nextInt(3);
+
+        if (offsetY <= sandLayer){
+            return getTextureFromBlock(Blocks.SAND);
+        } else if (offsetY <= dirtLayer) {
+            return getTextureFromBlock(Blocks.DIRT);
+        } else if (offsetY >= bedrockLayer) {
+            return getTextureFromBlock(Blocks.BEDROCK);
+        } else {
+            if (offsetY >= basaltLayer){
+                return getOreFromStone(Blocks.BASALT, random, tileX, tileY);
+            } else if (offsetY >= stoneLayer){
+                return getOreFromStone(Blocks.STONE, random, tileX, tileY);
+            } else {
+                if (offsetX <= graniteColumn){
+                    return getOreFromStone(Blocks.GRANITE, random, tileX, tileY);
+                } else if (offsetX >= limestoneColumn) {
+                    return getOreFromStone(Blocks.LIMESTONE, random, tileX, tileY);
+                }
+                return getOreFromStone(Blocks.STONE, random, tileX, tileY);
+            }
+        }
+    }
+
+    @Override
+    public void postProcessBackground(GuiAchievements gui, Random random, GuiAchievements.BGLayer layer, int orgX, int orgY) {
+        random.setSeed(random.nextLong() + key.hashCode()); // makes seed different for each instance of this class :)
+        if (layer.id == 0) {
+
+            int y = 5;
+            int delta = 0;
+            int tYMin = -2;
+            int tYMax = -6;
+            int lowestY = 0;
+            for (int _x = -100; _x < 100; _x++) {
+                delta += random.nextInt(2) - random.nextInt(2);
+                delta = MathHelper.clamp(delta, -3, 3);
+                int sign = (int) Math.signum(delta);
+                int _d = Math.abs(delta);
+                if (_d != 0) {
+                    y += sign * random.nextInt(_d);
+                }
+
+                if (y > tYMax) {
+                    delta -= 1;
+                }
+                if (y < tYMin) {
+                    delta += 1;
+                }
+                if (y > lowestY) y = lowestY;
+
+                for (int rY = y; rY - orgY >= 0; rY--) {
+                    if (rY == y) {
+                        layer.put(TextureRegistry.getTexture("minecraft:block/grass_side"), _x - orgX, rY - orgY);
+                    } else {
+                        layer.put(null, _x - orgX, rY - orgY);
+                    }
+                    gui.getLayer(1).put(null, _x - orgX, rY - orgY);
+                }
+            }
+
+            int[] brickPos = null;
+            int[] cobblePos = null;
+            int lastY = 0;
+            int cave = -1;
+            for (int _x = -100; _x <= 100; _x++) {
+                if (random.nextInt(20) == 0 && cave <= 0) {
+                    cave = 20 + random.nextInt(5) - random.nextInt(5);
+                }
+                if (cave > 0){
+                    lastY = (25 + random.nextInt(4) - random.nextInt(4));
+                    carveCircle(gui, layer, _x - orgX, lastY - orgY, 2 + random.nextInt(3));
+                }
+                if (cave == 0 && (-10 <= _x && _x <= 40)) {
+                    brickPos = new int[]{_x, lastY};
+                }
+                cave--;
+            }
+            cave = -1;
+            for (int _x = -100; _x <= 100; _x++) {
+                if (random.nextInt(10) == 0 && cave <= 0) {
+                    cave = 5 + random.nextInt(5) - random.nextInt(5);
+                }
+                if (cave > 0){
+                    carveCircle(gui, layer, _x - orgX, (10 + random.nextInt(2) - random.nextInt(2)) - orgY, random.nextInt(3));
+                }
+                cave--;
+            }
+
+            if (brickPos == null) {
+                brickPos = new int[]{5 + random.nextInt(20) + random.nextInt(20), 15 + random.nextInt(10)};
+            }
+
+            placeStructure(gui, dungeonBrick, brickPos[0] - orgX,brickPos[1] - orgY, (struct, cache) -> {
+                if (cache == null) {
+                    if (struct == chest || struct == spawner) {
+                        return struct;
+                    }
+                    return null;
+                }
+                return struct;
+            });
+            placeStructure(gui, dungeonCobble, -orgX + 5 + random.nextInt(20) + random.nextInt(20),-orgY + 5 + random.nextInt(5), (struct, cache) -> {
+                if (cache == null) {
+                    if (struct == chest || struct == spawner) {
+                        return struct;
+                    }
+                    return null;
+                }
+                return struct;
+            });
+        } else if (layer.id == 1) {
+            // Remove covered icons
+            IconCoordinate[] foreground = gui.getLayer(0).getData();
+            IconCoordinate[] background = layer.getData();
+            for (int i = 0; i < background.length; i++) {
+                if (foreground[i] != null && foreground[i] != spawner){
+                    background[i] = null;
+                }
+            }
+        }
+    }
+
+    protected void carveCircle(GuiAchievements gui, GuiAchievements.BGLayer layer, int centerX, int centerY, int radius){
+        for (int i = centerX - radius; i <= centerX + radius ; i++) {
+            for (int j = centerY - radius; j < centerY + radius; j++) {
+                double diffX = (i + 0.5) - centerX;
+                double diffY = (j + 0.5) - centerY;
+                if ((diffX * diffX) + (diffY * diffY) < radius * radius){
+                    layer.put(null, i, j);
+                }
+            }
+        }
+    }
+
+    protected void placeStructure(GuiAchievements gui, PageStructure structure, int tileX, int tileY, @Nullable BiFunction<IconCoordinate, IconCoordinate, IconCoordinate> coordinateProcessor) {
+        if (coordinateProcessor == null) {
+            coordinateProcessor = (i, i2) -> i;
+        }
+        for (int layer = 0; layer < structure.layers; layer++) {
+            GuiAchievements.BGLayer cache = gui.getLayer(layer);
+            if (cache != null) {
+                for (int _x = 0; _x < structure.width; _x++) {
+                    for (int _y = 0; _y < structure.height; _y++) {
+                        IconCoordinate coordinate = structure.getIcon(_x, _y, layer);
+                        cache.put(coordinateProcessor.apply(coordinate, cache.get(tileX + _x, tileY + _y)), tileX + _x, tileY + _y);
+                    }
+                }
+            }
+        }
+    }
+
+    private static final WeightedRandomBag<Integer> oreBag = new WeightedRandomBag<>();
+
+    protected IconCoordinate getOreFromStone(Block stoneBlock, Random random, int tileX, int tileY){
+        oreBag.clear();
+
+        random.setSeed(random.nextLong());
+
+        final int coalStart = 2;
+        final int coalEnd = 20;
+
+        final int ironStart = 2;
+        final int ironEnd = 25;
+
+        final int goldStart = 20;
+        final int goldEnd = 35;
+
+        final int diamondStart = 25;
+        final int diamondEnd = 35;
+
+        final int lapisStart = 25;
+        final int lapisEnd = 35;
+
+        final int redstoneStart = 20;
+        final int redstoneEnd = 35;
+
+        oreBag.addEntry(-1, 300);
+
+        if (tileY >= coalStart && tileY <= coalEnd){
+            oreBag.addEntry(ORE_COAL, 15);
+        }
+
+        if (tileY >= ironStart && tileY <= ironEnd){
+            oreBag.addEntry(ORE_IRON, 15);
+        }
+
+        if (tileY >= goldStart && tileY <= goldEnd){
+            oreBag.addEntry(ORE_GOLD, 3);
+        }
+
+        if (tileY >= diamondStart && tileY <= diamondEnd){
+            oreBag.addEntry(ORE_DIAMOND, 1);
+        }
+
+        if (tileY >= lapisStart && tileY <= lapisEnd){
+            oreBag.addEntry(ORE_LAPIS, 2);
+        }
+
+        if (tileY >= redstoneStart && tileY <= redstoneEnd){
+            oreBag.addEntry(ORE_REDSTONE, 5);
+        }
+
+        int oreIndex = oreBag.getRandom(random);
+
+        if (oreIndex >= 0){
+            if (stoneBlock == Blocks.STONE){
+                return getTextureFromBlock(STONE_ORES[oreIndex]);
+            } else if (stoneBlock == Blocks.BASALT) {
+                return getTextureFromBlock(BASALT_ORES[oreIndex]);
+            } else if (stoneBlock == Blocks.GRANITE) {
+                return getTextureFromBlock(GRANITE_ORES[oreIndex]);
+            } else if (stoneBlock == Blocks.LIMESTONE) {
+                return getTextureFromBlock(LIMESTONE_ORES[oreIndex]);
+            }
+        }
+
+        return getTextureFromBlock(stoneBlock);
+    }
+
+//    @Override
+//    public IconCoordinate getBackgroundTile(Random random, int tileX, int tileY) {
+//        int randomY = random.nextInt(Math.max(1 + tileY, 1)) + (tileY) / 2;
+//        IconCoordinate texture = getTextureFromBlock(Blocks.SAND);
+//        Block[] oreArray = STONE_ORES;
+//        if (randomY >= 28 || tileY > 24) {
+//            oreArray = BASALT_ORES;
+//        } if(randomY > 37 || tileY >= 35) {
+//            texture = getTextureFromBlock(Blocks.BEDROCK);
+//        } else if(randomY == 22) {
+//            if(random.nextInt(2) == 0) {
+//                texture = getTextureFromBlock(oreArray[ORE_DIAMOND]);
+//            } else {
+//                texture = getTextureFromBlock(oreArray[ORE_REDSTONE]);
+//            }
+//        } else if(randomY == 10) {
+//            texture = getTextureFromBlock(oreArray[ORE_IRON]);
+//        } else if(randomY == 8) {
+//            texture = getTextureFromBlock(oreArray[ORE_COAL]);
+//        } else if(randomY > 4) {
+//            texture = getTextureFromBlock(Blocks.STONE);
+//            if (randomY >= 28 || tileY > 24) {
+//                texture = getTextureFromBlock(Blocks.BASALT);
+//            }
+//        } else if(randomY > 0) {
+//            texture = getTextureFromBlock(Blocks.DIRT);
+//        }
+//        return texture;
+//    }
+
+    @Override
+    public @NotNull ItemStack getIcon() {
+        return icon;
+    }
+
+    @Override
+    public @NotNull List<Achievement> getAchievements() {
+        return achievementList;
+    }
+
+    @Override
+    public double getCompletionFraction(StatsCounter counter) {
+        int completed = 0;
+        for (Achievement a : achievementList){
+            if (counter.isUnlocked(a)){
+                completed++;
+            }
+        }
+        return completed / (double)achievementList.size();
+    }
+
+    @Override
+    public int backgroundLayers() {
+        return 2;
+    }
+
+    @Override
+    public int backgroundColor() {
+        return 0x76b6ff;
+    }
+
+    @Override
+    public boolean hasAchievement(Achievement achievement) {
+        return achievementList.contains(achievement);
+    }
+
+    @Override
+    public IconCoordinate getAchievementIcon(Achievement achievement) {
+        return TextureRegistry.getTexture(achievement.getType().texture);
+    }
+
+    @Override
+    public int lineColorLocked(boolean isHovered) {
+        return 0x000000;
+    }
+
+    @Override
+    public int lineColorUnlocked(boolean isHovered) {
+        return 0x707070;
+    }
+
+    @Override
+    public int lineColorCanUnlock(boolean isHovered) {
+        return 0x00ff00;
+    }
+
+    private static final IconCoordinate chest = TextureRegistry.getTexture("minecraft:block/chest_planks_oak_front");
+    private static final IconCoordinate spawner = getTextureFromBlock(Blocks.MOBSPAWNER);
+
+    protected static PageStructure dungeonBrick = new PageStructure(new Object[][][]
+        {
+            {
+                {Blocks.BRICK_CLAY, Blocks.BRICK_CLAY, Blocks.BRICK_CLAY, Blocks.BRICK_CLAY, Blocks.BRICK_CLAY, Blocks.BRICK_CLAY,  Blocks.BRICK_CLAY},
+                {Blocks.BRICK_CLAY, null,              null,              null,              null,              null,               Blocks.BRICK_CLAY},
+                {Blocks.BRICK_CLAY, null,              null,              null,              null,              null,               Blocks.BRICK_CLAY},
+                {Blocks.BRICK_CLAY, null,              null,              Blocks.MOBSPAWNER, null,              chest,              Blocks.BRICK_CLAY},
+                {Blocks.BRICK_CLAY, Blocks.BRICK_CLAY, Blocks.BRICK_CLAY, Blocks.BRICK_CLAY, Blocks.BRICK_CLAY, Blocks.BRICK_CLAY,  Blocks.BRICK_CLAY},
+            },
+            {
+                {Blocks.BRICK_CLAY, Blocks.BRICK_CLAY, Blocks.BRICK_CLAY, Blocks.BRICK_CLAY, Blocks.BRICK_CLAY, Blocks.BRICK_CLAY,  Blocks.BRICK_CLAY},
+                {Blocks.BRICK_CLAY, Blocks.BRICK_CLAY, Blocks.BRICK_CLAY, Blocks.BRICK_CLAY, Blocks.BRICK_CLAY, Blocks.BRICK_CLAY,  Blocks.BRICK_CLAY},
+                {Blocks.BRICK_CLAY, Blocks.BRICK_CLAY, Blocks.BRICK_CLAY, Blocks.BRICK_CLAY, Blocks.BRICK_CLAY, Blocks.BRICK_CLAY,  Blocks.BRICK_CLAY},
+                {Blocks.BRICK_CLAY, Blocks.BRICK_CLAY, Blocks.BRICK_CLAY, Blocks.BRICK_CLAY, Blocks.BRICK_CLAY, Blocks.BRICK_CLAY,  Blocks.BRICK_CLAY},
+                {Blocks.BRICK_CLAY, Blocks.BRICK_CLAY, Blocks.BRICK_CLAY, Blocks.BRICK_CLAY, Blocks.BRICK_CLAY, Blocks.BRICK_CLAY,  Blocks.BRICK_CLAY},
+            },
+        }
+    );
+
+    protected static PageStructure dungeonCobble = new PageStructure(new Object[][][]
+        {
+            {
+                {Blocks.COBBLE_STONE,       Blocks.COBBLE_STONE,       Blocks.COBBLE_STONE,       Blocks.COBBLE_STONE_MOSSY, Blocks.COBBLE_STONE,       Blocks.COBBLE_STONE_MOSSY,  Blocks.COBBLE_STONE},
+                {Blocks.COBBLE_STONE,       null,                      null,                      null,                      null,                      null,                       Blocks.COBBLE_STONE_MOSSY},
+                {Blocks.COBBLE_STONE_MOSSY, null,                      null,                      null,                      null,                      null,                       Blocks.COBBLE_STONE},
+                {Blocks.COBBLE_STONE,       chest,                     null,                      Blocks.MOBSPAWNER,         null,                      null,                       Blocks.COBBLE_STONE_MOSSY},
+                {Blocks.COBBLE_STONE_MOSSY, Blocks.COBBLE_STONE,       Blocks.COBBLE_STONE_MOSSY, Blocks.COBBLE_STONE_MOSSY, Blocks.COBBLE_STONE_MOSSY, Blocks.COBBLE_STONE,        Blocks.COBBLE_STONE},
+            },
+            {
+                {Blocks.COBBLE_STONE,       Blocks.COBBLE_STONE,       Blocks.COBBLE_STONE,       Blocks.COBBLE_STONE_MOSSY, Blocks.COBBLE_STONE,       Blocks.COBBLE_STONE,        Blocks.COBBLE_STONE},
+                {Blocks.COBBLE_STONE,       Blocks.COBBLE_STONE_MOSSY, Blocks.COBBLE_STONE,       Blocks.COBBLE_STONE,       Blocks.COBBLE_STONE_MOSSY, Blocks.COBBLE_STONE,        Blocks.COBBLE_STONE},
+                {Blocks.COBBLE_STONE,       Blocks.COBBLE_STONE_MOSSY, Blocks.COBBLE_STONE,       Blocks.COBBLE_STONE_MOSSY, Blocks.COBBLE_STONE_MOSSY, Blocks.COBBLE_STONE,        Blocks.COBBLE_STONE},
+                {Blocks.COBBLE_STONE,       Blocks.COBBLE_STONE,       Blocks.COBBLE_STONE,       Blocks.COBBLE_STONE_MOSSY, Blocks.COBBLE_STONE_MOSSY, Blocks.COBBLE_STONE,        Blocks.COBBLE_STONE},
+                {Blocks.COBBLE_STONE,       Blocks.COBBLE_STONE,       Blocks.COBBLE_STONE,       Blocks.COBBLE_STONE,       Blocks.COBBLE_STONE,       Blocks.COBBLE_STONE,        Blocks.COBBLE_STONE},
+            },
+        }
+    );
+
+    public static class PageStructure {
+        private final IconCoordinate[] data;
+        public final int width;
+        public final int height;
+        public final int layers;
+        public PageStructure(Object[][][] structure) {
+            this.layers = structure.length;
+            this.width = structure[0][0].length;
+            this.height = structure[0].length;
+
+            data = new IconCoordinate[width * height * layers];
+            for (int l = 0; l < layers; l++) {
+                for (int x = 0; x < width; x++) {
+                    for (int y = 0; y < height; y++) {
+                        Object o = structure[l][y][x];
+                        IconCoordinate c = null;
+                        if (o instanceof Block) {
+                            c = getTextureFromBlock((Block) o);
+                        } else if (o instanceof IconCoordinate) {
+                            c = (IconCoordinate) o;
+                        }
+                        data[makeIndex(x, y, l)] = c;
+                    }
+                }
+            }
+        }
+        public PageStructure(int width, int height, int layers){
+            this.width = width;
+            this.height = height;
+            this.layers = layers;
+            this.data = new IconCoordinate[width * height * layers];
+        }
+
+        public PageStructure setIcon(IconCoordinate icon, int x, int y, int layer) {
+            if (x < 0 || x >= width || y < 0 || y >= height || layer < 0 || layer >= layers) return this;
+            data[makeIndex(x, y, layer)] = icon;
+            return this;
+        }
+
+        public IconCoordinate getIcon(int x, int y, int layer){
+            if (x < 0 || x >= width || y < 0 || y >= height || layer < 0 || layer >= layers) return null;
+            return data[makeIndex(x, y, layer)];
+        }
+
+        private int makeIndex(int x, int y, int layer) {
+            return x % width + y * width + layer * (width * height);
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/client/gui/achievements/pages/NetherPage.java b/src/main/java/net/minecraft/client/gui/achievements/pages/NetherPage.java
new file mode 100644
index 000000000..4eb6a4090
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/achievements/pages/NetherPage.java
@@ -0,0 +1,44 @@
+package net.minecraft.client.gui.achievements.pages;
+
+import net.minecraft.client.gui.achievements.GuiAchievements;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.core.achievement.Achievement;
+import net.minecraft.core.achievement.Achievements;
+import net.minecraft.core.block.Blocks;
+import org.jetbrains.annotations.NotNull;
+
+import java.util.Random;
+
+public class NetherPage extends DefaultPage{
+    public NetherPage() {
+        super("gui.achievements.page.nether", Blocks.NETHERRACK.getDefaultStack());
+    }
+    @Override
+    public @NotNull Achievement onOpenAchievement() {
+        return Achievements.BUILD_PICKAXE;
+    }
+    @Override
+    public IconCoordinate getBackgroundTile(GuiAchievements guiAchievements, int layer, Random random, int tileX, int tileY) {
+        int r = random.nextInt(5);
+        IconCoordinate texture = getTextureFromBlock(Blocks.NETHERRACK);
+        if (r == 0){
+            texture = getTextureFromBlock(Blocks.ORE_NETHERCOAL_NETHERRACK);
+        }
+        return texture;
+    }
+
+    @Override
+    public int lineColorLocked(boolean isHovered) {
+        return 0x002233;
+    }
+
+    @Override
+    public int lineColorUnlocked(boolean isHovered) {
+        return 0x707070;
+    }
+
+    @Override
+    public int lineColorCanUnlock(boolean isHovered) {
+        return 0xff0000;
+    }
+}
diff --git a/src/main/java/net/minecraft/client/gui/achievements/pages/OverworldPage.java b/src/main/java/net/minecraft/client/gui/achievements/pages/OverworldPage.java
new file mode 100644
index 000000000..fa95cd452
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/achievements/pages/OverworldPage.java
@@ -0,0 +1,9 @@
+package net.minecraft.client.gui.achievements.pages;
+
+import net.minecraft.core.block.Blocks;
+
+public class OverworldPage extends DefaultPage{
+    public OverworldPage() {
+        super("gui.achievements.page.overworld", Blocks.GRASS.getDefaultStack());
+    }
+}
diff --git a/src/main/java/net/minecraft/client/gui/createworld/ButtonComponent.java b/src/main/java/net/minecraft/client/gui/createworld/ButtonComponent.java
index bf2fbb3a6..34e983b56 100644
--- a/src/main/java/net/minecraft/client/gui/createworld/ButtonComponent.java
+++ b/src/main/java/net/minecraft/client/gui/createworld/ButtonComponent.java
@@ -2,7 +2,6 @@ package net.minecraft.client.gui.createworld;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.GuiButton;
-import net.minecraft.client.gui.GuiTexturedButton;
 import net.minecraft.client.gui.paged.PageComponent;
 import net.minecraft.client.render.FontRenderer;
 import net.minecraft.client.render.tessellator.Tessellator;
@@ -26,7 +25,8 @@ public abstract class ButtonComponent
     public ButtonComponent(String translationKey)
     {
         this.translationKey = translationKey;
-        this.resetButton = new GuiTexturedButton(0, "/assets/minecraft/textures/gui/gui.png", 0, 0, 40, 86, 20, 20);
+        this.resetButton = new GuiButton(0, 0, 0, 20, 20, "")
+            .setTextures("minecraft:gui/misc/icon_reset", "minecraft:gui/misc/icon_reset_highlighted", "minecraft:gui/misc/icon_reset");
     }
 
     public abstract void resetValue();
